import { Collection, Entity, ManyToOne, OneToMany, PrimaryKey, Property } from '@mikro-orm/core';
import { Character } from './character';
import { Sprite } from './sprite';
import { CharacterGender } from '../utilities/enums';

@Entity()
export class CharacterHair {
  @PrimaryKey()
  id!: number;

  @Property()
  name!: string;

  @Property()
  gender: CharacterGender = CharacterGender.MALE;

  @Property()
  isSelectable = false;

  @ManyToOne(() => Sprite, { nullable: true })
  sprite?: Sprite;

  @OneToMany(() => Character, character => character.characterHair)
  characters = new Collection<Character>(this);
}